/*
 *	fram.c
 *
 *	M62vC[
 *
 *	* Sat Feb 07 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

void
m6803_write(M6800* m6803, unsigned short addr, unsigned char data)
{
	DRIVER* driver = (DRIVER*)m6803;
	unsigned char* mem = driver->mem;
	AY38910* psg1;
	AY38910* psg2;

	switch(addr) {
	case 2:
		driver->port1 = data;
		return;
	case 3:
		/* Port2bit0Hi=>LoɂȂuԂɁAHiƂ̃rbgIŏo͂܂B */
		if((driver->port2 & 1) && !(data & 1)) {
			psg1 = &driver->psg1;
			psg2 = &driver->psg2;
			if(driver->port2 & 0x04) {
				if(driver->port2 & 0x08) ay38910_address(psg1, driver->port1);
				if(driver->port2 & 0x10) ay38910_address(psg2, driver->port1);
			} else {
				if(driver->port2 & 0x08) ay38910_write(psg1, driver->port1);
				if(driver->port2 & 0x10) ay38910_write(psg2, driver->port1);
			}
		}
		driver->port2 = data;
		return;
	}

	mem[addr] = data; /* o͏IĂXV!! */
}
